/*
Copyright  2007 Andrius da Costa Ribas <andriusmao@gmail.com>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.


compile me with -lm option
*/

#include <math.h>
int DownstairsSort(unsigned int *v, unsigned int size)
{
	int T;
	int i,j;
	int R;
	unsigned long long int sum=0;
	T=size+1;
	for(i=0;i<size;i++)
	{
		if (pow(T,v[i])<0) return -1; /*it means overflow, i.e., it can't be sorted by Downstairs Sort (yet) */
		sum=sum+pow(T,v[i]);
		if (sum<0) return -1; /*it means overflow, i.e., it can't be sorted by Downstairs Sort (yet) */
	}
	i=0;
	j=0;
	while (sum != 0)
	{
		R=sum % T;
		while (R>0)
		{
			v[i]=j;
			i++;
			R--;
		}
		j++;
		sum=sum/T;
	}
	return 0;
}
